<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/14/2013 *
 * ===================                          Last change: 01/14/2013 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mode-update.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Steps for updates of ext-server_name             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Schritte fuer Updates von ext-server_name        *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Add admin menu
addAdminMenuSql('misc', 'list_server_name', 'Verkehrte Domains auflisten', 'Listet alle als verkehrt erkannten Domains auf.', 4);
addAdminMenuSql('config', 'config_server_name', 'Server-Namen', 'Einstellungen f&uuml;r das Erzwingen des Hostnamens.', 10);

// Create table
addCreateTableSql('server_name_log', "
`server_name_id` BIGINT (20) NOT NULL AUTO_INCREMENT,
`server_name` VARCHAR (255) NOT NULL DEFAULT 'invalid',
`server_name_remote_addr` VARCHAR (15) NOT NULL DEFAULT '0.0.0.0',
`server_name_ua` TINYTEXT NULL DEFAULT NULL,
`server_name_referrer` TINYTEXT NULL DEFAULT NULL,
`server_name_added` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`server_name_counter` BIGINT (20) NOT NULL DEFAULT 1,
PRIMARY KEY (`server_name_id`)
", 'Logging of wrong SERVER_NAME');


addExtensionAddTableColumnSql('server_name_log', 'server_name_remote_addr', "VARCHAR (15) NOT NULL DEFAULT '0.0.0.0'");
addExtensionAddTableColumnSql('server_name_log', 'server_name_counter', 'BIGINT (20) NOT NULL DEFAULT 0');
addExtensionAddTableColumnSql('server_name_log', 'server_name_ua', 'TINYTEXT NULL DEFAULT NULL');
addExtensionAddTableColumnSql('server_name_log', 'server_name_referrer', 'TINYTEXT NULL DEFAULT NULL');

addConfigAddSql('ap_server_name', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
addConfigAddSql('ap_server_name_since', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (getOneDay() * 7));

// Register filter
registerFilter(__FILE__, __LINE__, 'extra_autopurge', 'SERVER_NAME_EXTRA_AUTOPURGE', FALSE, TRUE, isExtensionDryRun());

// [EOF]
?>
