<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/28/2012 *
 * ===================                          Last change: 11/28/2012 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : menu_filter.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter for adding generic menu advert template (+ separator)
function FILTER_ADD_GENERIC_MENU_ADVERT ($filterData) {
	// Should we display adverts in this menu?
	if (($filterData['exclusive'] === FALSE) && (getConfig($filterData['mode'] . '_menu_advert_enabled') == 'Y') && ($filterData['action'] != 'admin')) {
		// Display advert template
		$filterData['output'] .= loadTemplate('menu_' . $filterData['mode'] . '_advert_' . $filterData['action'], TRUE);

		// Add separator again
		$filterData['output'] .= loadTemplate('menu_separator', TRUE, $filterData['mode']);
	} // END - if

	// Return filter data
	return $filterData;
}

// Filter to add generic advert to end of menu
function FILTER_ADD_GENERIC_MENU_ADVERT_END ($filterData) {
	// Should we display adverts in this menu?
	if (($filterData['exclusive']) && (getConfig($filterData['mode'] . '_menu_advert_enabled') == 'Y') && ($filterData['action'] != 'admin')) {
		// Add separator again
		$filterData['content'] .= loadTemplate('menu_separator', TRUE, $filterData['mode']);

		// Display advert template
		$filterData['content'] .= loadTemplate('menu_' . $filterData['mode'] . '_advert_end', TRUE);
	} // END - if

	// Return filter data
	return $filterData;
}

// [EOF]
?>
