<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/12/2003 *
 * ===================                          Last change: 12/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_points.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Setup welcome-points for registration etc.       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstellen der Willkommensgutschrift usw.        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Init variables
$message = '';

// Is the 'sub' parameter set?
if (isGetRequestElementSet('sub')) {
	// Yes, then do some sanity-checks
	switch (getRequestElement('sub')) {
		case 'points':
			if ((!isPostRequestElementSet('points_register')) || (!isPostRequestElementSet('points_ref'))) {
				unsetPostRequestElement('ok');
			} // END - if
			break;
	} // END - switch
} else {
	// Display overview
	setGetRequestElement('sub', 'overview');
}

// Is a form sent?
if ((isFormSent('do_delete')) || (isFormSent('do_edit')) || (isFormSent('do_add')) || (isFormSent('save_config'))) {
	// Init SQLs
	initSqls();
	switch (getRequestElement('sub')) {
		case 'points':
			adminSaveSettingsFromPostData();
			break;

		case 'settings':
			$REF = bigintval(postRequestElement('ref_payout'));
			updateConfiguration(
				array('allow_direct_pay', 'ref_payout'),
				array(postRequestElement('allow_direct_pay'), $REF)
			);
			if ((getRefPayout() == '0') && (postRequestElement('ref_payout') > 0)) {
				// Update account's ref_payout for "must-confirm"
				addSql(sprintf('UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`ref_payout`=(%s - `mails_confirmed`)
WHERE
	`mails_confirmed` < %s', $REF, $REF));
			} elseif ((getRefPayout() > 0) && (postRequestElement('ref_payout') == '0')) {
				// Update account's ref_payout for "not-must-confirm"
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `ref_payout`=0 WHERE `ref_payout` > 0");
				// @TODO Rewrite these two lines for new user_points columns (e.g. locked_order_points) with a filter
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_points` SET `points`=`points`+`locked_points` WHERE `locked_points` > 0");
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_points` SET `locked_points`=0 WHERE `locked_points` > 0");
			}
			break;
	} // END - switch

	// Is there an array?
	if ((getRequestElement('sub') != 'points') && (ifSqlsRegistered())) {
		// Default is failed-message
		$message = '<span class="bad">{--SETTINGS_NOT_SAVED--}</span>';

		if (countSqls() > 0) {
			// Run all SQL commands
			runFilterChain('run_sqls');

			// Entry saved...
			$message = '{--SETTINGS_SAVED--}';

			// Destroy config cache file here...
			rebuildCache('config', 'config');
		} // END - if

		// Remove SQL queries
		unsetSqls();
	} // END - if

	// Shall we display a message?
	if (!empty($message)) {
		// When do so...
		displayMessage($message);
	} // END - if
} elseif (getRequestElement('sub') == 'settings') {
	// Setup some settings like direct pay and so on
	// Including new add-mode for one-time referral bonus
	foreach (array('allow_direct_pay') as $entry) {
		$content[$entry . '_y'] = '';
		$content[$entry . '_n'] = '';
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	// Load template
	loadTemplate('admin_config_point_settings', FALSE, $content);
} elseif (getRequestElement('sub') == 'points') {
	// Load template
	loadTemplate('admin_config_sub_points');
} else {
	// Display selection box
	loadTemplate('admin_config_points');
}

// [EOF]
?>
