<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/19/2003 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unconfirmed.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Unconfirmed mails                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbestaetigte Mails                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	exit();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

// Essential extension ext-mailid must be active
if (!isExtensionActive('mailid')) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=mailid%}');
	return;
} // END - if

// Shall we display a mail?
if ((isGetRequestElementSet('bonusid')) && (isExtensionActive('bonus'))) {
	// Display bonus mail by loading it's full data
	$result_data = sqlQueryEscaped('SELECT
	`id`,
	`subject`,
	`timestamp`,
	`cat_id`,
	`points`,
	`text`,
	`is_notify`,
	`data_type`,
	`time`,
	`url`
FROM
	`{?_MYSQL_PREFIX?}_bonus`
WHERE
	`id`=%s
LIMIT 1',
		array(bigintval(getRequestElement('bonusid'))), __FILE__, __LINE__);

	// Load data
	$content = sqlFetchArray($result_data);

	// Translate some data
	$content['timestamp'] = generateDateTime($content['timestamp'], '2');
	$content['userid'] = getMemberId();
	$content['user_mail_status'] = '{%message,MEMBER_MAIL_BONUS_CONFIRMED_UNKNOWN=' . $content['id'] . '%}';

	// Is ext-user active?
	if (isExtensionActive('user')) {
		// Default is never confirmed
		$content['user_mail_status'] = '{%message,MEMBER_MAIL_BONUS_NEVER_CONFIRMED=' . $content['id'] . '%}';

		// Get the timestamp from the mail
		$confirmedStamp = getEpocheTimeFromUserStats('bonusid', $content['id']);

		// Have confirmed it?
		if ($confirmedStamp > 0) {
			// Get timestamp from insert
			$content['user_mail_status'] = '{%message,MEMBER_MAIL_BONUS_CONFIRMED_ON=' . generateDateTime($confirmedStamp, '2') . '%}';
		} // END - if
	} // END - if

	// Display it depending on mail (data) type
	loadTemplate('member_mail_bonus_' . strtolower($content['data_type']), FALSE, $content);

	// Free result
	sqlFreeResult($result_data);
} elseif (isGetRequestElementSet('mailid')) {
	// Display regular member mail by loading its full data
	$result_data = sqlQueryEscaped("SELECT
	`id` AS `stats_id`,
	`pool_id`,
	`subject`,
	`timestamp_ordered`,
	`cat_id`,
FROM
	`{?_MYSQL_PREFIX?}_user_stats` AS `s`
WHERE
	`id`=%s
LIMIT 1",
		array(bigintval(getRequestElement('mailid'))), __FILE__, __LINE__);

	// Load data
	$content = sqlFetchArray($result_data);
	$content = merge_array($content, getPoolDataFromId($content['pool_id']));

	// Translate some data
	$content['timestamp_ordered'] = generateDateTime($content['timestamp_ordered'], '2');
	// @TODO This call cannot be saved as EL code cannot be "framed" in other EL code
	$content['userid'] = getMemberId();
	$content['user_mail_status'] = '{%message,MEMBER_MAIL_NORMAL_CONFIRMED_UNKNOWN=' . $content['id'] . '%}';

	// Is ext-user active?
	if (isExtensionActive('user')) {
		// Default is never confirmed
		$content['user_mail_status'] = '{%message,MEMBER_MAIL_NORMAL_NEVER_CONFIRMED=' . $content['id'] . '%}';

		// Get the timestamp from the mail
		$confirmedStamp = getEpocheTimeFromUserStats('mailid', $content['id']);

		// Have confirmed it?
		if ($confirmedStamp > 0) {
			// Get timestamp from insert
			$content['user_mail_status'] = '{%message,MEMBER_MAIL_NORMAL_CONFIRMED_ON=' . generateDateTime($confirmedStamp, '2') . '%}';
		} // END - if
	} // END - if

	// Display it depending on mail (data) type
	loadTemplate('member_mail_normal_' . strtolower($content['data_type']), FALSE, $content);

	// Free result
	sqlFreeResult($result_data);
}

if (isExtensionActive('bonus')) {
	// Load bonus id
	$result = sqlQueryEscaped("SELECT `stats_id`, `bonus_id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `bonus_id` DESC, stats_id DESC",
		array(getMemberId()), __FILE__, __LINE__);
} else {
	// Don't load bonus id if ext-bonus is not installed
	$result = sqlQueryEscaped("SELECT `stats_id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `stats_id` DESC",
		array(getMemberId()), __FILE__, __LINE__);
}

// Mails left for confirmation?
if (!ifSqlHasZeroNumRows($result)) {
	// Please confirm these mails!
	$sum = '0'; $OUT = '';

	// Init content
	$content = array();

	// @TODO Try to rewrite this to $content = SQL_FETCHARRAY()
	while ($row = sqlFetchArray($result)) {
		// Load data from stats table...
		$cat = '';
		$result_data = FALSE;
		$message = '{--MEMBER_GENERAL_MAIL_PROBLEM--}';
		$data = $row['stats_id'] . '/' . $row['bonus_id'] . '/' . $row['link_type'];
		switch ($row['link_type']) {
			case 'NORMAL':
				$result_data = sqlQueryEscaped("SELECT
	`s`.`subject`,
	`s`.`timestamp_ordered` AS `timestamp`,
	`s`.`cat_id`,
	`s`.`payment_id`,
	`p`.`sender`
FROM
	`{?_MYSQL_PREFIX?}_user_stats` AS `s`
LEFT JOIN
	`{?_MYSQL_PREFIX?}_pool` AS `p`
ON
	`s`.`pool_id`=`p`.`id`
WHERE
	`s`.`id`=%s
LIMIT 1",
					array(bigintval($row['stats_id'])), __FILE__, __LINE__);
				$row['link_type'] = 'mailid';
				$data = $row['stats_id'];
				$message = '{--NORMAL_MAIL_PROBLEM--}';
				break;

			case 'BONUS':
				$result_data = sqlQueryEscaped("SELECT `subject`, `timestamp`, `cat_id`, `points`, NULL FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
					array(bigintval($row['bonus_id'])), __FILE__, __LINE__);
				$row['link_type'] = 'bonusid';
				$data = $row['bonus_id'];
				$message = '{--BONUS_MAIL_PROBLEM--}';
				break;

			default: // Unknown type detected!
				reportBug(__FILE__, __LINE__, sprintf("Unknown mail type %s detected.", $row['link_type']));
				break;
		} // END - switch

		// Data found to this mail?
		if ((sqlNumRows($result_data) == 1) && (($row['link_type'] == 'mailid') || ($row['link_type'] == 'bonusid'))) {
			// Mail was found
			$rowData = sqlFetchArray($result_data);

			// Subject line found?
			if (empty($rowData['subject'])) {
				// No subject line!
				$rowData['subject'] = '{--DEFAULT_SUBJECT--}';
			} // END - if

			// Prepare sender id
			if ((isValidId($rowData['sender'])) && ($row['link_type'] == 'mailid')) {
				// Sender id
				$rowData['sender'] = bigintval($rowData['sender']);
			} elseif ($row['link_type'] == 'bonusid') {
				// Is admin
				$rowData['sender'] = '{--USERNAME_ADMIN_SHORT--}';
			} else {
				// Deleted
				$rowData['sender'] = '{--EMAIL_STATUS_DELETED--}';
			}

			// Prepare data for template
			// @TODO cat_id is unused
			$rowData = array(
				'data'              => bigintval($data),
				// @TODO This 'userid' cannot be saved because of encapsulated EL code
				'userid'            => getMemberId(),
				'link_type'         => $row['link_type'],
				'subject'           => $rowData['subject'],
				'sender'            => $rowData['sender'],
				'timestamp_ordered' => generateDateTime($rowData['timestamp_ordered'], 2),
				'payment_id'        => $rowData['payment_id'],
			);

			// Load row template
			if (isShowPointsUnconfirmedEnabled()) {
				$OUT .= loadTemplate('member_list_unconfirmed_row', TRUE, $rowData);
			} else {
				$OUT .= loadTemplate('member_list_unconfirmed_nopoints_row', TRUE, $rowData);
			}

			// Count points (price)
			$sum += getPaymentPrice($rowData['payment_id']);
		} else {
			// Prepare data for template
			$rowData = array(
				'data'    => $data,
				'message' => $message,
			);

			// Display points or not?
			if (isShowPointsUnconfirmedEnabled()) {
				$OUT .= loadTemplate('member_list_unconfirmed_404_row', TRUE, $rowData);
			} else {
				$OUT .= loadTemplate('member_list_unconfirmed_nopoints_404_row', TRUE, $rowData);
			}
		}

		// Free result
		sqlFreeResult($result_data);
	} // END - while

	// Free memory
	sqlFreeResult($result);

	// Remember total points
	$content['total_points'] = $sum;

	// Remember all generated rows in constant for the template
	$content['rows'] = $OUT;

	// Load main template
	if (isShowPointsUnconfirmedEnabled()) {
		loadTemplate('member_list_unconfirmed', FALSE, $content);
	} else {
		loadTemplate('member_list_unconfirmed_nopoints', FALSE, $content);
	}
} else {
	// No mails left to confirm... :)
	displayMessage('{--MEMBER_NO_MAILS_TO_CONFIRM--}');
}

// [EOF]
?>
